% Lundberg model

clear;
format longEng;
delta=0.03; lambda=1; theta=1; c=2;
a1=0.02917305718455041525509308092552716230167;
a2=-0.485-a1;
C=-.8941389842817982186856330514088361449301;
M=9.180097300194138281602346432151383130465;
ds=1/100; da=1/500;
S=0:ds:40;
Alpha=da:da:1;
KS=length(S);
KA=length(Alpha);
V1=zeros(KS,KA); V2=V1; 
W=zeros(1,KS); V0=W; Psi=W; Ws=W; 

Psi=exp(-S/2)/2;
gM=(1-C)*a1*exp(a1*M)+C*a2*exp(a2*M);
sM=round(M/ds+1);

for i=1:KS
    s=(i-1)*ds;
    W(i)=(1-C)*exp(a1*s)+C*exp(a2*s);
    Ws(i)=(1-C)*a1*exp(a1*s)+C*a2*exp(a2*s);
    if s<=M
        V0(i)=W(i)/gM;
    else
        V0(i)=V0(i-1)+ds;
    end;
end;

for k=1:KS
    for al=1:KA
        alpha=al*da; s=(k-1)*ds;
        sa=-2*log(alpha);
        k1=floor((s-sa)/ds);
        if k1<1
            V1(k,al)=0;
        else
            V1(k,al)=V0(k1);
        end;
    end;
end;

s0=round(2/ds+1);
alpha0=round(0.2*KA);

figure(1); plot(Alpha,V1(s0,:)); grid on; hold on; drawnow;
